#include <sourcemod>
#include <influx/simpleranks>
#include <shop>

public Plugin myinfo = 
{
	name = "[SHOP] Transfer influx rankpoint",
	author = "wAries",
	description = "Credits to INFLUX RP",
	version = "1.1",
	url = "discord.gg/ChTyPUG"
};

public void OnPluginStart()
{
    RegConsoleCmd("sm_transfer", CMD_transfer);

    CreateConVar("sm_shop_credits_coeff", "1000", "Множитель кредитов к 1 RP", _ ,true, 1.0).AddChangeHook(CR_COEFF);

    AutoExecConfig(true, "shop_transferpoint");
}

public void OnMapStart()
{
    CR_COEFF(FindConVar("sm_shop_credits_coeff"), NULL_STRING, NULL_STRING);
}

public void CR_COEFF(ConVar cv, const char[] cOld, const char[] cNew)
{
    if(!cv)
        return;

    coefficient(true, cv.IntValue);
}

int coefficient(bool rewrite = false, int newValue = 1000)
{
    static int iNow = 1000;

    if(rewrite)
        iNow = newValue;
    
    return iNow;
}

public Action CMD_transfer(int iClient, int iArg)
{
    if(!iClient || !IsClientInGame(iClient))
        return Plugin_Handled;

    MenuMain(iClient, coefficient()).Display(iClient, MENU_TIME_FOREVER);
    return Plugin_Handled;
}

Menu MenuMain(int iClient, int iTransfer)
{
    Menu hMenu = new Menu(MenuMainCallBack);

    int iCountcr = Shop_GetClientCredits(iClient);
    hMenu.SetTitle("[ Пункт обмена кредитов в R.P. ] \n \nКурс валют: %i кр. => %i поинт \nУ вас кредитов: %i кр. \n \n", coefficient(), 1, iCountcr);

    char szBuffer[PLATFORM_MAX_PATH], szCount[32];
    FormatEx(szBuffer, sizeof szBuffer, "Обменять (%i кр. на %i RP.) \n \n", iTransfer, iTransfer/coefficient());
    IntToString(iTransfer, szCount, sizeof szCount);

    hMenu.AddItem(szCount, szBuffer, (iCountcr < iTransfer) ? ITEMDRAW_DISABLED : ITEMDRAW_DEFAULT);

    FormatEx(szCount, sizeof szCount, "%ia", iTransfer + coefficient());
    hMenu.AddItem(szCount, "Прибавить [+]", ((iTransfer + coefficient()) <= iCountcr) ? ITEMDRAW_DEFAULT : ITEMDRAW_DISABLED);

    FormatEx(szCount, sizeof szCount, "%ia", iTransfer - coefficient());
    hMenu.AddItem(szCount, "Уменьшить [-]", ((iTransfer - coefficient()) > 0) ? ITEMDRAW_DEFAULT : ITEMDRAW_DISABLED);

    return hMenu;

}

public int MenuMainCallBack(Menu hMenu, MenuAction action, int iClient, int iOpt)
{
    if(action == MenuAction_End)
    {
        hMenu.Close();
        return;
    }
    
    else if(action == MenuAction_Select)
    {
        char szOpt[32];
        hMenu.GetItem(iOpt, szOpt, sizeof szOpt);

        int iPos; int iValue;
        if((iPos = FindCharInString(szOpt, 'a')) != -1)
        {
            szOpt[iPos] = 0;
            iValue = StringToInt(szOpt);

            MenuMain(iClient, iValue).Display(iClient, MENU_TIME_FOREVER);
            return;  
        }
        
        transferStart(iClient, StringToInt(szOpt));
    }
}

void transferStart(int iClient, int iTransfer)
{
    Shop_SetClientCredits(iClient, Shop_GetClientCredits(iClient) - iTransfer);

    int iPoint = iTransfer/coefficient();
    if(!Influx_AddClientSimpleRankPoints(iClient, iPoint))
    {
        LogError("[SHOP] Клиент не доступен");
        return;
    }

    PrintToChat(iClient, "[SHOP] \x04Списано \x02%i кредитов. \x04Добавлено - \x02%i поинтов!", iTransfer, iPoint);
}